/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IamSecurityTokenServicePreferencesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.13.1/docs/resources/iam_security_token_service_preferences#global_endpoint_token_version IamSecurityTokenServicePreferences#global_endpoint_token_version}
    */
    readonly globalEndpointTokenVersion: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/aws/5.13.1/docs/resources/iam_security_token_service_preferences#id IamSecurityTokenServicePreferences#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/aws/5.13.1/docs/resources/iam_security_token_service_preferences aws_iam_security_token_service_preferences}
*/
export declare class IamSecurityTokenServicePreferences extends cdktf.TerraformResource {
    static readonly tfResourceType = "aws_iam_security_token_service_preferences";
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/aws/5.13.1/docs/resources/iam_security_token_service_preferences aws_iam_security_token_service_preferences} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IamSecurityTokenServicePreferencesConfig
    */
    constructor(scope: Construct, id: string, config: IamSecurityTokenServicePreferencesConfig);
    private _globalEndpointTokenVersion?;
    get globalEndpointTokenVersion(): string;
    set globalEndpointTokenVersion(value: string);
    get globalEndpointTokenVersionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
